import { computed as v, ref as m, watch as U, onMounted as re, openBlock as o, createElementBlock as r, normalizeStyle as C, renderSlot as I, normalizeProps as ne, guardReactiveProps as ie, createElementVNode as f, toDisplayString as X, createCommentVNode as h, unref as c, createVNode as de, Fragment as A, renderList as D, createBlock as ve } from "vue";
import { u as he, c as ce, t as ye, _ as T, o as fe, e as Z, g as pe, w as M, $ as ge, a0 as me, X as ke, s as P, R as q, i as H, f as Y } from "./index-B9RAElpI.js";
import { u as J } from "./useNestedProp-DuruL3Nt.js";
import be from "./vue-ui-skeleton-DVYD_VSe.js";
import { t as _e, u as xe } from "./useResponsive-CoxXLe23.js";
import { _ as we } from "./PackageVersion-C_FFs0BP.js";
import { _ as $e } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Le = ["id"], Ne = ["xmlns", "viewBox"], Ce = ["width", "height"], Ie = ["id"], Me = ["stop-color"], Pe = ["stop-color"], Ve = ["id"], ze = ["stop-color"], Se = ["stop-color"], We = ["id"], Ae = ["stop-color"], De = ["stop-color"], Te = { key: 1 }, Oe = ["d", "fill"], Be = ["d", "fill"], Ee = ["d", "stroke", "stroke-width"], Fe = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Ge = ["x", "y", "width", "height", "fill", "rx"], Re = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], je = ["x1", "x2", "y1", "y2", "stroke", "stroke-dasharray", "stroke-width"], Ue = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], Xe = ["x", "y", "font-size", "font-weight", "fill"], Ze = ["x", "y", "height", "width", "onMouseenter", "onClick"], qe = {
  __name: "vue-ui-sparkline",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    },
    showInfo: {
      type: Boolean,
      default: !0
    },
    selectedIndex: {
      type: Number,
      default: void 0
    },
    heightRatio: {
      type: Number,
      default: 1
    },
    forcedPadding: {
      type: Number,
      default: 30
    }
  },
  emits: ["hoverIndex", "selectDatapoint"],
  setup(_, { emit: V }) {
    const i = _, { vue_ui_sparkline: K } = he(), $ = v(() => !!i.dataset && i.dataset.length), p = m(ce()), z = m(null), O = m(null), B = m(null), e = v({
      get: () => E(),
      set: (t) => t
    });
    function E() {
      const t = J({
        userConfig: i.config,
        defaultConfig: K
      });
      return t.theme ? {
        ...J({
          userConfig: ye.vue_ui_sparkline[t.theme] || i.config,
          defaultConfig: t
        })
      } : t;
    }
    const L = v(() => T({
      data: i.dataset,
      threshold: e.value.downsample.threshold
    }));
    U(() => i.config, (t) => {
      e.value = E(), G(), l.value.chartWidth = e.value.style.chartWidth;
    }, { deep: !0 }), U(() => i.dataset, (t) => {
      b.value = T({
        data: i.dataset.map((u) => ({
          ...u,
          value: [void 0].includes(u.value) ? null : u.value
        })),
        threshold: e.value.downsample.threshold
      });
    }, { deep: !0 });
    const b = m(Q());
    function Q() {
      return T({
        data: i.dataset.map((t) => e.value.style.animation.show ? {
          ...t,
          value: null
        } : {
          ...t,
          value: [void 0].includes(t.value) ? null : t.value
        }),
        threshold: e.value.downsample.threshold
      });
    }
    const F = m(null);
    re(() => {
      if (G(), e.value.style.animation.show && i.dataset.length > 1) {
        let a = function() {
          u < L.value.length ? (b.value.push(L.value[u]), setTimeout(() => {
            requestAnimationFrame(a);
          }, t)) : b.value = L.value, u += 1;
        };
        b.value = [];
        const t = e.value.style.animation.animationFrames / i.dataset.length;
        let u = 0;
        a();
      }
    });
    function G() {
      if (fe(i.dataset) ? Z({
        componentName: "VueUiSparkline",
        type: "dataset"
      }) : i.dataset.forEach((t, u) => {
        pe({
          datasetObject: t,
          requiredAttributes: ["period", "value"]
        }).forEach((a) => {
          Z({
            componentName: "VueUiSparkline",
            type: "datasetSerieAttribute",
            property: a,
            index: u
          });
        });
      }), e.value.responsive) {
        const t = _e(() => {
          const { width: u, height: a } = xe({
            chart: z.value,
            title: e.value.style.title.show && i.showInfo ? O.value : null,
            source: B.value
          });
          l.value.width = u, l.value.height = a, l.value.chartWidth = e.value.style.chartWidth / 500 * u, l.value.padding = i.forcedPadding / 500 * u;
        });
        F.value = new ResizeObserver(t), F.value.observe(z.value.parentNode);
      }
    }
    const l = m({
      height: 80 * i.heightRatio,
      width: 500,
      chartWidth: e.value.style.chartWidth,
      padding: i.forcedPadding
    }), ee = m(6), s = v(() => ({
      top: 12,
      left: 0,
      right: l.value.width,
      bottom: l.value.height - 3,
      start: i.showInfo && e.value.style.dataLabel.show && e.value.style.dataLabel.position === "left" ? l.value.width - l.value.chartWidth : l.value.padding,
      width: i.showInfo && e.value.style.dataLabel.show ? l.value.chartWidth : l.value.width - l.value.padding,
      height: l.value.height - 12
    })), S = v(() => Math.min(...b.value.map((t) => isNaN(t.value) || [void 0, null, "NaN", NaN, 1 / 0, -1 / 0].includes(t.value) ? 0 : t.value || 0))), te = v(() => Math.max(...b.value.map((t) => isNaN(t.value) || [void 0, null, "NaN", NaN, 1 / 0, -1 / 0].includes(t.value) ? 0 : t.value || 0))), x = v(() => {
      const t = S.value >= 0 ? 0 : S.value;
      return Math.abs(t);
    }), ae = v(() => te.value + x.value + ee.value), N = v(() => s.value.bottom - s.value.height * W(x.value));
    function W(t) {
      return t / ae.value;
    }
    const g = v(() => L.value.length - 1), n = v(() => b.value.map((t, u) => {
      const a = isNaN(t.value) || [void 0, null, "NaN", NaN, 1 / 0, -1 / 0].includes(t.value) ? 0 : t.value || 0;
      return {
        absoluteValue: a,
        period: t.period,
        plotValue: a + x.value,
        toMax: W(a + x.value),
        x: s.value.start + u * (s.value.width / (g.value + 1) > l.padding ? l.padding : s.value.width / (g.value + 1)),
        y: s.value.bottom - s.value.height * W(a + x.value),
        id: `plot_${p.value}_${u}`,
        color: w.value ? e.value.style.bar.color : e.value.style.area.useGradient ? M(e.value.style.line.color, 0.05 * (1 - u / g.value)) : e.value.style.line.color,
        width: s.value.width / (g.value + 1) > l.padding ? l.padding : s.value.width / (g.value + 1)
      };
    })), le = v(() => {
      const t = { x: n.value[0].x, y: l.value.height - 6 }, u = { x: n.value[n.value.length - 1].x, y: l.value.height - 6 }, a = [];
      return n.value.forEach((d) => {
        a.push(`${d.x},${d.y} `);
      }), [t.x, t.y, ...a, u.x, u.y].toString();
    }), y = m(void 0);
    function ue(t, u) {
      y.value = t, V("hoverIndex", { index: u });
    }
    function se() {
      y.value = void 0, V("hoverIndex", { index: void 0 });
    }
    const k = v(() => {
      if ($.value) {
        const t = n.value.map((a) => a.absoluteValue), u = t.reduce((a, d) => a + d, 0);
        return {
          latest: n.value[n.value.length - 1].absoluteValue,
          sum: u,
          average: u / n.value.length,
          median: ge(t),
          trend: me(n.value.map(({ x: a, y: d, absoluteValue: j }) => ({
            x: a,
            y: d,
            value: j
          }))).trend
        };
      } else
        return {
          latest: null,
          sum: null,
          average: null,
          median: null,
          trend: null
        };
    }), R = v(() => $.value ? e.value.style.dataLabel.valueType === "latest" ? k.value.latest : e.value.style.dataLabel.valueType === "sum" ? k.value.sum : e.value.style.dataLabel.valueType === "average" ? k.value.average : 0 : 0), w = v(() => e.value.type && e.value.type === "bar");
    function oe(t, u) {
      V("selectDatapoint", { datapoint: t, index: u });
    }
    return (t, u) => (o(), r("div", {
      ref_key: "sparklineChart",
      ref: z,
      class: "vue-ui-sparkline",
      id: p.value,
      style: C(`width:100%;font-family:${e.value.style.fontFamily};`)
    }, [
      I(t.$slots, "before", ne(ie({
        selected: y.value,
        latest: k.value.latest,
        sum: k.value.sum,
        average: k.value.average,
        median: k.value.median,
        trend: k.value.trend
      })), void 0, !0),
      e.value.style.title.show && _.showInfo ? (o(), r("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: O,
        class: "vue-ui-sparkline-title",
        style: C(`display:flex;align-items:center;width:100%;color:${e.value.style.title.color};background:${e.value.style.backgroundColor};justify-content:${e.value.style.title.textAlign === "left" ? "flex-start" : e.value.style.title.textAlign === "right" ? "flex-end" : "center"};height:${e.value.style.title.fontSize * 2}px;font-size:${e.value.style.title.fontSize}px;font-weight:${e.value.style.title.bold ? "bold" : "normal"};`)
      }, [
        f("span", {
          style: C(`padding:${e.value.style.title.textAlign === "left" ? "0 0 0 12px" : e.value.style.title.textAlign === "right" ? "0 12px 0 0" : "0"}`)
        }, X(y.value ? y.value.period : e.value.style.title.text), 5)
      ], 4)) : h("", !0),
      $.value ? (o(), r("svg", {
        key: 1,
        xmlns: c(ke),
        viewBox: `0 0 ${l.value.width} ${l.value.height}`,
        style: C(`background:${e.value.style.backgroundColor};overflow:visible`)
      }, [
        de(we),
        t.$slots["chart-background"] ? (o(), r("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: l.value.width <= 0 ? 10 : l.value.width,
          height: l.value.height <= 0 ? 10 : l.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          I(t.$slots, "chart-background", {}, void 0, !0)
        ], 8, Ce)) : h("", !0),
        f("defs", null, [
          f("linearGradient", {
            x1: "0%",
            y1: "0%",
            x2: "100%",
            y2: "0%",
            id: `sparkline_gradient_${p.value}`
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": c(P)(c(M)(e.value.style.area.color, 0.05), e.value.style.area.opacity)
            }, null, 8, Me),
            f("stop", {
              offset: "100%",
              "stop-color": c(P)(e.value.style.area.color, e.value.style.area.opacity)
            }, null, 8, Pe)
          ], 8, Ie),
          f("linearGradient", {
            x2: "0%",
            y2: "100%",
            id: `sparkline_bar_gradient_pos_${p.value}`
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": e.value.style.bar.color
            }, null, 8, ze),
            f("stop", {
              offset: "100%",
              "stop-color": c(M)(e.value.style.bar.color, 0.05)
            }, null, 8, Se)
          ], 8, Ve),
          f("linearGradient", {
            x2: "0%",
            y2: "100%",
            id: `sparkline_bar_gradient_neg_${p.value}`
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": c(M)(e.value.style.bar.color, 0.05)
            }, null, 8, Ae),
            f("stop", {
              offset: "100%",
              "stop-color": e.value.style.bar.color
            }, null, 8, De)
          ], 8, We)
        ]),
        e.value.style.area.show && !w.value && n.value[0] ? (o(), r("g", Te, [
          e.value.style.line.smooth ? (o(), r("path", {
            key: 0,
            d: `M ${n.value[0].x},${s.value.bottom} ${c(q)(n.value)} L ${n.value.at(-1).x},${s.value.bottom} Z`,
            fill: e.value.style.area.useGradient ? `url(#sparkline_gradient_${p.value})` : c(P)(e.value.style.area.color, e.value.style.area.opacity)
          }, null, 8, Oe)) : (o(), r("path", {
            key: 1,
            d: `M${le.value}Z`,
            fill: e.value.style.area.useGradient ? `url(#sparkline_gradient_${p.value})` : c(P)(e.value.style.area.color, e.value.style.area.opacity)
          }, null, 8, Be))
        ])) : h("", !0),
        e.value.style.line.smooth && !w.value ? (o(), r("path", {
          key: 2,
          d: `M ${c(q)(n.value)}`,
          stroke: e.value.style.line.color,
          fill: "none",
          "stroke-width": e.value.style.line.strokeWidth,
          "stroke-linecap": "round"
        }, null, 8, Ee)) : h("", !0),
        (o(!0), r(A, null, D(n.value, (a, d) => (o(), r("g", null, [
          d < n.value.length - 1 && !e.value.style.line.smooth && !w.value ? (o(), r("line", {
            key: 0,
            x1: a.x,
            x2: n.value[d + 1].x,
            y1: a.y,
            y2: n.value[d + 1].y,
            stroke: a.color,
            "stroke-width": e.value.style.line.strokeWidth,
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            "shape-rendering": "geometricPrecision"
          }, null, 8, Fe)) : h("", !0),
          w.value ? (o(), r("rect", {
            key: 1,
            x: a.x - a.width / 2,
            y: a.absoluteValue > 0 ? a.y : N.value,
            width: a.width,
            height: Math.abs(a.y - N.value),
            fill: a.absoluteValue > 0 ? `url(#sparkline_bar_gradient_pos_${p.value})` : `url(#sparkline_bar_gradient_neg_${p.value})`,
            rx: e.value.style.bar.borderRadius
          }, null, 8, Ge)) : h("", !0),
          e.value.style.verticalIndicator.show && (y.value && a.id === y.value.id || _.selectedIndex === d) ? (o(), r("line", {
            key: 2,
            x1: a.x,
            x2: a.x,
            y1: s.value.top - 6,
            y2: s.value.bottom,
            stroke: e.value.style.verticalIndicator.color || a.color,
            "stroke-width": e.value.style.verticalIndicator.strokeWidth,
            "stroke-linecap": "round",
            "stroke-dasharray": e.value.style.verticalIndicator.strokeDasharray || 0
          }, null, 8, Re)) : h("", !0)
        ]))), 256)),
        S.value < 0 ? (o(), r("line", {
          key: 3,
          x1: s.value.start,
          x2: s.value.start + s.value.width - 16,
          y1: N.value,
          y2: N.value,
          stroke: e.value.style.zeroLine.color,
          "stroke-dasharray": e.value.style.zeroLine.strokeWidth * 2,
          "stroke-width": e.value.style.zeroLine.strokeWidth,
          "stroke-linecap": "round"
        }, null, 8, je)) : h("", !0),
        e.value.style.plot.show ? (o(!0), r(A, { key: 4 }, D(n.value, (a, d) => (o(), r("g", null, [
          y.value && a.id === y.value.id || _.selectedIndex === d ? (o(), r("circle", {
            key: 0,
            cx: a.x,
            cy: a.y,
            r: e.value.style.plot.radius,
            fill: a.color,
            stroke: e.value.style.plot.stroke,
            "stroke-width": e.value.style.plot.strokeWidth
          }, null, 8, Ue)) : h("", !0)
        ]))), 256)) : h("", !0),
        _.showInfo && e.value.style.dataLabel.show ? (o(), r("text", {
          key: 5,
          x: e.value.style.dataLabel.position === "left" ? 12 + e.value.style.dataLabel.offsetX : s.value.width + 12 + e.value.style.dataLabel.offsetX,
          y: l.value.height / 2 + e.value.style.dataLabel.fontSize / 2.5 + e.value.style.dataLabel.offsetY,
          "font-size": e.value.style.dataLabel.fontSize,
          "font-weight": e.value.style.dataLabel.bold ? "bold" : "normal",
          fill: e.value.style.dataLabel.color
        }, X(y.value ? c(H)(
          e.value.style.dataLabel.formatter,
          y.value.absoluteValue,
          c(Y)({ p: e.value.style.dataLabel.prefix, v: y.value.absoluteValue, s: e.value.style.dataLabel.suffix, r: e.value.style.dataLabel.roundingValue }),
          { datapoint: y.value }
        ) : c(H)(
          e.value.style.dataLabel.formatter,
          R.value,
          c(Y)({ p: e.value.style.dataLabel.prefix, v: R.value, s: e.value.style.dataLabel.suffix, r: e.value.style.dataLabel.roundingValue })
        )), 9, Xe)) : h("", !0),
        (o(!0), r(A, null, D(n.value, (a, d) => (o(), r("rect", {
          x: a.x - (s.value.width / (g.value + 1) > l.value.padding ? l.value.padding : s.value.width / (g.value + 1)) / 2,
          y: s.value.top - 6,
          height: s.value.height + 6,
          width: s.value.width / (g.value + 1) > l.value.padding ? l.value.padding : s.value.width / (g.value + 1),
          fill: "transparent",
          onMouseenter: (j) => ue(a, d),
          onMouseleave: se,
          onClick: () => oe(a, d)
        }, null, 40, Ze))), 256)),
        I(t.$slots, "svg", { svg: l.value }, void 0, !0)
      ], 12, Ne)) : h("", !0),
      t.$slots.source ? (o(), r("div", {
        key: 2,
        ref_key: "source",
        ref: B,
        dir: "auto"
      }, [
        I(t.$slots, "source", {}, void 0, !0)
      ], 512)) : h("", !0),
      $.value ? h("", !0) : (o(), ve(be, {
        key: 3,
        config: {
          type: "sparkline",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            sparkline: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 12, Le));
  }
}, at = /* @__PURE__ */ $e(qe, [["__scopeId", "data-v-eb31fee7"]]);
export {
  at as default
};
